SystemOrganization addCategory: #TusLibros!

Object subclass: #Cart
	instanceVariableNames: 'products catalog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:31'!
with: aCatalog
	^self new initializeWith: aCatalog ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:55'!
add: aProduct 
	(catalog includes: aProduct) ifFalse: [ Error signal: 'Product is not in catalog' ].
	products add: aProduct.
	
! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 21:09'!
contains: aProduct
	^ products includes: aProduct.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:21'!
initialize
	products := Bag new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:25'!
initializeWith: aCatalog 
	products := Bag new.
	catalog := aCatalog! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:21'!
isEmpty
	^ products isEmpty.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 20:55'!
priceOf: aProduct  
	^catalog priceOf: aProduct.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:30'!
productCount
	^ products size.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 19:02'!
products
 ^products.! !

Object subclass: #Cashier
	instanceVariableNames: 'salesBook'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cashier class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 17:54'!
emptyCartCheckoutErrorMessage
	^ 'Cart is empty'! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 18:17'!
withSalesBook: aSalesBook 
	^self new initializeWithSalesBook: aSalesBook.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 20:54'!
checkout: aCart using: aCreditCard
	| sale |
	
	(aCart isEmpty) ifTrue: [ Error signal: (self class emptyCartCheckoutErrorMessage) ].
	
	sale := Sale new.
	aCart products do: [ :aProduct | sale addProduct: aProduct withPrice: (aCart priceOf: aProduct) ].

	salesBook add: sale.
	
	^ sale! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 18:18'!
initializeWithSalesBook: aSalesBook 
	salesBook := aSalesBook.! !

Object subclass: #Catalog
	instanceVariableNames: 'productsPrices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Catalog methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 20:25'!
add: aProduct withPrice: aPrice  
	productsPrices at: aProduct put: aPrice ! !

!Catalog methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 20:30'!
includes: aProduct  
	^productsPrices includesKey: aProduct ! !

!Catalog methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 20:25'!
initialize
	productsPrices := Dictionary new.! !

!Catalog methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/4/2013 20:42'!
priceOf: aProduct  
	^(productsPrices at: aProduct).! !

Object subclass: #Sale
	instanceVariableNames: 'priceDetail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Sale class
	instanceVariableNames: 'products'!

Sale class
	instanceVariableNames: 'products'!

!Sale class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 20:46'!
total
	
	products do: [  ] ! !

!Sale class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 19:06'!
withProducts: aProducts 
	products:= aProducts! !

!Sale methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/4/2013 20:37'!
addProduct: aProduct withPrice: price  
	priceDetail add: (SaleItem initializeWith: aProduct and: price).! !

!Sale methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/4/2013 20:22'!
initialize
	priceDetail := Bag new.! !

!Sale methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/4/2013 20:39'!
total
	| sumTotal |
	sumTotal := 0.
	priceDetail do: [ :saleItem | sumTotal := sumTotal + saleItem price ].
	
	^sumTotal! !

Object subclass: #SaleItem
	instanceVariableNames: 'product price'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

SaleItem class
	instanceVariableNames: 'product price'!

SaleItem class
	instanceVariableNames: 'product price'!

!SaleItem class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/4/2013 20:38'!
initializeWith: aSmallInteger and: aSmallInteger2 
	self shouldBeImplemented.! !

!SaleItem class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/4/2013 20:40'!
price
	^ price! !

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

TusLibrosTest class
	instanceVariableNames: 'products'!

TusLibrosTest class
	instanceVariableNames: 'products'!

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 21:00'!
aBook
	^1! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 20:42'!
aBookWithISBN: isbn  
	^isbn! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 18:27'!
aCartWithCatalog: aCatalog  
	^Cart with: aCatalog! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 20:43'!
aCashier
	^Cashier withSalesBook: self anEmptySalesBook.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 20:22'!
aCatalog
	^Catalog new! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/4/2013 20:47'!
aCatalogWithProduct: aProduct 
	| catalog |
	
	catalog := Catalog new.
	catalog add: aProduct withPrice: 1.
	
	^catalog! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 18:00'!
aCreditCard
	^'Visa'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:34'!
anEmptyCart
	^	Cart with: (self aCatalog)! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 20:23'!
anEmptyCatalog
	^Catalog new! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 18:16'!
anEmptySalesBook
	^OrderedCollection new! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'FacundoPippia 6/3/2013 18:22'!
testAddProductShouldFailIfProductIsNotInCatalog
	| cart |
	
	cart := self aCartWithCatalog: self anEmptyCatalog.
	
	self should: [cart add: self aBook] 
		raise: Error 
		withExceptionDo: [ :anError |
			self assert: anError messageText = 'Product is not in catalog'.
			self assert: cart isEmpty ]! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'FacundoPippia 5/29/2013 20:18'!
testCartShouldBeEmptyAfterCreation

	self assert: self anEmptyCart isEmpty

 ! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'FacundoPippia 6/3/2013 18:22'!
testCartShouldContainAProductThatWasAdded

	| aCart book|
	book := self aBook.
	aCart := self aCartWithCatalog: (Set with: book).
	aCart add: book.

	self assert: (aCart contains: book).! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'FacundoPippia 6/3/2013 18:22'!
testCartShouldContainTheAmountOfBooksAdded
	"comment stating purpose of message"

	| cart book anotherBook catalog|
	book := self aBook.
	anotherBook := self aBook.
	catalog := (Set with: book with: anotherBook).
	cart := self aCartWithCatalog: catalog.
	cart add: book.
	cart add: anotherBook.
	self assert: (cart productCount = 2).! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'FacundoPippia 6/3/2013 18:22'!
testCartShouldNotBeEmptyAfterAddingABook
	"comment stating purpose of message"
	|cart book catalog|
	book := self aBook.
	catalog := (Set with: book).
	cart := self aCartWithCatalog: (catalog).
	cart add: book.
	self deny: (cart isEmpty).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 17:59'!
testCheckoutShouldFailIfCartIsEmpty
	| cart cashier salesBook creditCard |
	
	cashier := self aCashier.
	cart := self anEmptyCart.
	salesBook := self anEmptySalesBook.
	creditCard := self aCreditCard.
	
	self should: [ cashier checkout: cart using: creditCard ] 
		raise: Error 
		withExceptionDo: [ :anError | 
			self assert: salesBook isEmpty.
			self assert: anError messageText = Cashier emptyCartCheckoutErrorMessage.
		]! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 18:27'!
testSaleIsCreatedWhenCartIsNotEmpty
	| book cart salesBook cashier sale |
	
	book := self aBook.
	
	cart := self aCartWithCatalog: (self aCatalogWithProduct: book).
	cart add: book.
	
	salesBook := self anEmptySalesBook.
	
	cashier := Cashier withSalesBook: salesBook.
		
	sale := cashier checkout: cart using: self aCreditCard.
	
	self assert: (salesBook includes: sale).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/4/2013 20:54'!
testSaleTotalIsSumOfCartProductsPrices
	| cart book anotherBook catalog sale |
	
	book := self aBookWithISBN: 1.
	anotherBook := self aBookWithISBN: 2.
	catalog := self anEmptyCatalog.
	catalog add: book withPrice: 4.
	catalog add: anotherBook withPrice: 5.
	
	cart := self aCartWithCatalog: catalog.
	cart add: book.
	cart add: anotherBook.

	self halt.	
	sale := self aCashier checkout: cart using: self aCreditCard. 

	self assert: (sale total = 9).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 21:10'!
testSaleTotalShouldBeSumOfCartProductPricesWhenThereAreRepeatedProducts
	| cart book catalog sale |
	
	book := self aBookWithISBN: 1.
	catalog := self anEmptyCatalog.
	catalog add: book withPrice: 4.

	cart := self aCartWithCatalog: catalog.
	cart add: book.
	cart add: book.
	
	sale := self aCashier checkout: cart using: self aCreditCard. 
	
	self assert: (sale total = 8).! !
